﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#NoTrayIcon
#SingleInstance off

ver = 1.1
FileAppend, .bars extractor v%ver%`n,*
If 0 = 0
{
MsgBox, Select the .bars file you want to extract.
FileSelectFile, bars, 1,, .bars extractor v%ver%,*.bars
If ErrorLevel = 1
    ExitApp
}

If 0 = 1
    bars = %1%

StringGetPos, dot, bars, ., R
StringLeft, barsfolder, bars, %dot%
barsfolder = %barsfolder%_extracted

;BARS magic
BinRead(bars,magic,4)
If magic != 42415253
    {
    FileAppend, not a .bars file.,*
    If 0 = 0
        MsgBox, not a .bars file.
    ExitApp
    }

;file count
BinRead(bars,barsfile_count,4,12)
barsfile_count := hexToDecimal(barsfile_count)
FileAppend, %barsfile_count% files found.`n,*

;unknown data
BinRead(bars,barsunknown,barsfile_count*4,16)

;offset index
barsindex_offset := 16 + barsfile_count*4
BinRead(bars,barsindex,barsfile_count*8,barsindex_offset)
barsindex_count := barsfile_count*2
Loop, %barsindex_count%
    {
    StringLeft, barsindex_%A_Index%, barsindex, 8
    barsindex_%A_Index% := hexToDecimal(barsindex_%A_Index%)
    StringTrimLeft, barsindex, barsindex, 8
    If A_Index = 2
        barsindex_second := barsindex_%A_Index%
    barsindex_last := barsindex_%A_Index%
    }

;content
Loop, %barsindex_count%
    {
    barsindex_next := A_Index + 2
    If barsindex_%barsindex_next% =
        {
        BinRead(bars,barswrite,barsindex_second-barsindex_%A_Index%,barsindex_%A_Index%)
        StringGetPos, barswrite_STRG, barswrite, 53545247
        barswrite_name_lenght_pos := barswrite_STRG+9
        barswrite_name_pos := barswrite_STRG+17
        StringMid, barswrite_name_lenght, barswrite, %barswrite_name_lenght_pos%, 8
        barswrite_name_lenght := hexToDecimal(barswrite_name_lenght)*2
        StringMid, barswrite_name, barswrite, %barswrite_name_pos%, %barswrite_name_lenght%
        barswrite_name := Hex2ASCII(barswrite_name)
        FileAppend, extracting %barswrite_name%.AMTA`n,*
        BinWrite(barsfolder . "\" . barswrite_name . ".AMTA",barswrite)
        BinRead(bars,barswrite,0,barsindex_last)
        FileAppend, extracting %barswrite_name%.bfwav`n,*
        BinWrite(barsfolder . "\" . barswrite_name . ".bfwav",barswrite)
        Break
        }
    Else
        {
        BinRead(bars,barswrite,barsindex_%barsindex_next%-barsindex_%A_Index%,barsindex_%A_Index%)
        IfNotExist, %barsfolder%
            FileCreateDir, %barsfolder%
        barsindex_oddoreven := OddOrEven(A_Index)
        If barsindex_oddoreven = Odd
            {
            StringGetPos, barswrite_STRG, barswrite, 53545247
            barswrite_name_lenght_pos := barswrite_STRG+9
            barswrite_name_pos := barswrite_STRG+17
            StringMid, barswrite_name_lenght, barswrite, %barswrite_name_lenght_pos%, 8
            barswrite_name_lenght := hexToDecimal(barswrite_name_lenght)*2
            StringMid, barswrite_name, barswrite, %barswrite_name_pos%, %barswrite_name_lenght%
            barswrite_name := Hex2ASCII(barswrite_name)
            FileAppend, extracting %barswrite_name%.AMTA`n,*
            BinWrite(barsfolder . "\" . barswrite_name . ".AMTA",barswrite)
            }
        Else
            {
            FileAppend, extracting %barswrite_name%.bfwav`n,*
            BinWrite(barsfolder . "\" . barswrite_name . ".bfwav",barswrite)
            }
        }
    }
;BinWrite(barsfolder . "\unknown.data", barsunknown)

FileAppend, Done :), *
If 0 = 0
    MsgBox, Done :)

ExitApp

/* ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; BinRead ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
|  - Open binary file
|  - Read n bytes (n = 0: all)
|  - From offset (offset < 0: counted from end)
|  - Close file
|  data (replaced) <- file[offset + 0..n-1]
|  Return #bytes actually read
*/ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BinRead(file, ByRef data, n=0, offset=0)
{
   h := DllCall("CreateFile","Str",file,"Uint",0x80000000,"Uint",3,"UInt",0,"UInt",3,"Uint",0,"UInt",0)
   IfEqual h,-1, SetEnv, ErrorLevel, -1
   IfNotEqual ErrorLevel,0,Return,0 ; couldn't open the file

   m = 0                            ; seek to offset
   IfLess offset,0, SetEnv,m,2
   r := DllCall("SetFilePointerEx","Uint",h,"Int64",offset,"UInt *",p,"Int",m)
   IfEqual r,0, SetEnv, ErrorLevel, -3
   IfNotEqual ErrorLevel,0, {
      t = %ErrorLevel%              ; save ErrorLevel to be returned
      DllCall("CloseHandle", "Uint", h)
      ErrorLevel = %t%              ; return seek error
      Return 0
   }

   TotalRead = 0
   data =
   IfEqual n,0, SetEnv n,0xffffffff ; almost infinite

   format = %A_FormatInteger%       ; save original integer format
   SetFormat Integer, Hex           ; for converting bytes to hex

   Loop %n%
   {
      result := DllCall("ReadFile","UInt",h,"UChar *",c,"UInt",1,"UInt *",Read,"UInt",0)
      if (!result or Read < 1 or ErrorLevel)
         break
      TotalRead += Read             ; count read
      c += 0                        ; convert to hex
      StringTrimLeft c, c, 2        ; remove 0x
      c = 0%c%                      ; pad left with 0
      StringRight c, c, 2           ; always 2 digits
      data = %data%%c%              ; append 2 hex digits
   }

   IfNotEqual ErrorLevel,0, SetEnv,t,%ErrorLevel%

   h := DllCall("CloseHandle", "Uint", h)
   IfEqual h,-1, SetEnv, ErrorLevel, -2
   IfNotEqual t,,SetEnv, ErrorLevel, %t%

   SetFormat Integer, %format%      ; restore original format
   Totalread += 0                   ; convert to original format
   Return TotalRead
}

/* ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; BinWrite ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
|  - Open binary file
|  - (Over)Write n bytes (n = 0: all)
|  - From offset (offset < 0: counted from end)
|  - Close file
|  data -> file[offset + 0..n-1], rest of file unchanged
|  Return #bytes actually written
*/ ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BinWrite(file, data, n=0, offset=0)
{
   ; Open file for WRITE (0x40..), OPEN_ALWAYS (4): creates only if it does not exists
   h := DllCall("CreateFile","str",file,"Uint",0x40000000,"Uint",0,"UInt",0,"UInt",4,"Uint",0,"UInt",0)
   IfEqual h,-1, SetEnv, ErrorLevel, -1
   IfNotEqual ErrorLevel,0,Return,0 ; couldn't create the file

   m = 0                            ; seek to offset
   IfLess offset,0, SetEnv,m,2
   r := DllCall("SetFilePointerEx","Uint",h,"Int64",offset,"UInt *",p,"Int",m)
   IfEqual r,0, SetEnv, ErrorLevel, -3
   IfNotEqual ErrorLevel,0, {
      t = %ErrorLevel%              ; save ErrorLevel to be returned
      DllCall("CloseHandle", "Uint", h)
      ErrorLevel = %t%              ; return seek error
      Return 0
   }

   TotalWritten = 0
   m := Ceil(StrLen(data)/2)
   If (n <= 0 or n > m)
       n := m
   Loop %n%
   {
      StringLeft c, data, 2         ; extract next byte
      StringTrimLeft data, data, 2  ; remove  used byte
      c = 0x%c%                     ; make it number
      result := DllCall("WriteFile","UInt",h,"UChar *",c,"UInt",1,"UInt *",Written,"UInt",0)
      TotalWritten += Written       ; count written
      if (!result or Written < 1 or ErrorLevel)
         break
   }

   IfNotEqual ErrorLevel,0, SetEnv,t,%ErrorLevel%

   h := DllCall("CloseHandle", "Uint", h)
   IfEqual h,-1, SetEnv, ErrorLevel, -2
   IfNotEqual t,,SetEnv, ErrorLevel, %t%

   Return TotalWritten
}

hexToDecimal(str)
{
    static _0:=0,_1:=1,_2:=2,_3:=3,_4:=4,_5:=5,_6:=6,_7:=7,_8:=8,_9:=9,_a:=10,_b:=11,_c:=12,_d:=13,_e:=14,_f:=15
    str:=ltrim(str,"0x `t`n`r"),   len := StrLen(str),  ret:=0
    Loop,Parse,str
      ret += _%A_LoopField%*(16**(len-A_Index))
    return ret
}

Hex2ASCII(fHexString) {
	Loop Parse, fHexString
	NewHexString .= A_LoopField (Mod(A_Index,2) ? "" : ",")
	Loop, Parse, NewHexString, `,
		ConvString .= Chr("0x" A_LoopField)
	Return ConvString
	}

OddOrEven(num)
{
    return ((Num & 1) != 0) ? "Odd" : "Even"
}